//
// Created by illyum on 8/16/2024.
//

#ifndef SERIAL_PORT_H
#define SERIAL_PORT_H

#include <string>
#include <vector>

class SerialPort {
public:
    virtual ~SerialPort() = default;

    virtual bool open(const std::string& portName, int baudRate) = 0;
    virtual void close() = 0;
    virtual bool configure(int baudRate, int dataBits, int stopBits, int parity) = 0;
    virtual bool writeData(const std::vector<unsigned char>& data) = 0;
    virtual bool sendBreak() = 0;
};

#endif // SERIAL_PORT_H