//
// Created by illyum on 8/16/2024.
//

// FIXME:
// I don't have a mac to test it on so... I have zero idea if
// this will work, let alone compile

#if defined(__linux__) || defined(__APPLE__)
#include "serial_port.h"
#include <fcntl.h>
#include <unistd.h>
#include <termios.h>
#include <iostream>

class PosixSerialPort : public SerialPort {
public:
    PosixSerialPort() : fd(-1) {}

    ~PosixSerialPort() {
        close();
    }

    bool open(const std::string& portName, int baudRate) override {
        fd = ::open(portName.c_str(), O_RDWR | O_NOCTTY | O_NDELAY);
        if (fd == -1) {
            std::cerr << "Error opening " << portName << " port" << std::endl;
            return false;
        }
        return configure(baudRate, CS8, 1, 0);
    }

    void close() override {
        if (fd != -1) {
            ::close(fd);
            fd = -1;
        }
    }

    bool configure(int baudRate, int dataBits, int stopBits, int parity) override {
        struct termios options;
        if (tcgetattr(fd, &options) < 0) {
            std::cerr << "Error getting COM port attributes" << std::endl;
            return false;
        }

        cfsetispeed(&options, baudRate);
        cfsetospeed(&options, baudRate);

        options.c_cflag &= ~CSIZE;
        options.c_cflag |= dataBits;

        options.c_cflag &= ~PARENB;
        if (parity) options.c_cflag |= PARENB;

        options.c_cflag &= ~CSTOPB;
        if (stopBits == 2) options.c_cflag |= CSTOPB;

        options.c_cflag |= CLOCAL | CREAD;

        options.c_iflag &= ~(IXON | IXOFF | IXANY);
        options.c_lflag &= ~(ICANON | ECHO | ECHOE | ISIG);
        options.c_oflag &= ~OPOST;

        options.c_cc[VMIN] = 0;
        options.c_cc[VTIME] = 5;

        tcflush(fd, TCIFLUSH);
        return tcsetattr(fd, TCSANOW, &options) == 0;
    }

    bool writeData(const std::vector<unsigned char>& data) override {
        return ::write(fd, data.data(), data.size()) != -1;
    }

    bool sendBreak() override {
        return tcsendbreak(fd, 0) == 0;
    }

private:
    int fd;
};
#endif
